//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ImpDlgIBXF.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "QImport2Wizard"
#pragma resource "*.dfm"
TfmImpDlgIBX *fmImpDlgIBX;
//---------------------------------------------------------------------------
__fastcall TfmImpDlgIBX::TfmImpDlgIBX(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfmImpDlgIBX::FormCreate(TObject *Sender)
{
  IBDatabase1->DatabaseName = ExtractFilePath(Application->ExeName) + "..\\..\\data\\country.gdb";
  IBDatabase1->Connected = true;
  IBTransaction1->Active = true;
  IBTable1->TableName = "country";
  IBTable1->Active = true;
}
//---------------------------------------------------------------------------
void __fastcall TfmImpDlgIBX::FormDestroy(TObject *Sender)
{
  IBTable1->Active = False;
  IBTransaction1->Active = false;
  IBDatabase1->Connected = false;
}
//---------------------------------------------------------------------------
void __fastcall TfmImpDlgIBX::btImportClick(TObject *Sender)
{
  QImportWizard1->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TfmImpDlgIBX::QImportWizard1AfterImport(TObject *Sender)
{
  IBTable1->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TfmImpDlgIBX::QImportWizard1BeforePost(TObject *Sender,
  TQImportRow *Row, bool &Accept)
{
  if (chbUseBeforePost->Checked)
    for (int i = 0; i <= Row->Count - 1; i++)
      if (Row->Items[i]->Value == "Argentina")
      {
        Accept = false;
        return;
      }
}
//---------------------------------------------------------------------------
void __fastcall TfmImpDlgIBX::Button1Click(TObject *Sender)
{
  if ((pcDestinations->ActivePage == tshDataSet) ||
      (pcDestinations->ActivePage == tshDBGrid))
  {
    IBQuery1->ExecSQL();
    IBQuery1->Transaction->Commit();
    IBTable1->Open();
  }
  else if (pcDestinations->ActivePage == tshListView)
  {
    ListView->Items->BeginUpdate();
    try
    {
      ListView->Items->Clear();
    }
    __finally
    {
      ListView->Items->EndUpdate();
    }
  }
  else if (pcDestinations->ActivePage == tshStringGrid)
  {
    for (int i = 1; i <= StringGrid->RowCount - 1; i++)
      for (int j = 0;  j <= StringGrid->ColCount - 1; j++)
        StringGrid->Cells[j][i] = EmptyStr;
  }
}
//---------------------------------------------------------------------------
void __fastcall TfmImpDlgIBX::pcDestinationsChange(TObject *Sender)
{
  if (pcDestinations->ActivePage == tshDataSet)
    QImportWizard1->ImportDestination = qidDataSet;
  else if (pcDestinations->ActivePage == tshDBGrid)
    QImportWizard1->ImportDestination = qidDBGrid;
  else if (pcDestinations->ActivePage == tshListView)
    QImportWizard1->ImportDestination = qidListView;
  else if (pcDestinations->ActivePage == tshStringGrid)
    QImportWizard1->ImportDestination = qidStringGrid;
}

void __fastcall TfmImpDlgIBX::QImportWizard1NeedCommit(TObject *Sender)
{
  if ((QImportWizard1->ImportDestination == qidDataSet) ||
      (QImportWizard1->ImportDestination == qidDBGrid))
   IBTable1->Transaction->CommitRetaining();
}
//---------------------------------------------------------------------------
